//define remote and include libraries
#define IR_SMALLD_NECx
#include <IRsmallDecoder.h>
#include <RedBot.h>
RedBotSensor IRSensor1 = RedBotSensor(A2); // initialize a sensor object on A2
RedBotSensor IRSensor2 = RedBotSensor(A1); // initialize a sensor object on A1
RedBotSensor IRSensor3 = RedBotSensor(A0); // initialize a sensor object on A0
//Declare pin numbers
int AIN1 = 13;
int AIN2 = 12;
int PWMA1 = 11;
int AIN3 = 8; 
int AIN4 = 9;
int PWMA2 = 10;
int flag = 0;
int TRIGPIN = 3;
int ECHOPIN = 4;
int button = 21;
int buttontemp = 0;
int RECVPIN = 2;
//declare global variables
int L_Sensor, R_Sensor, M_Sensor;
int x;
int distance;
int sp=100;
//setup IR Line sensor
IRsmallDecoder irDecoder(RECVPIN);
irSmallD_t irData;
void setup() {
  //setup pinmode
  Serial.begin(9600);
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);
  pinMode(PWMA1, OUTPUT);
  pinMode(AIN3, OUTPUT);
  pinMode(AIN4, OUTPUT);
  pinMode(PWMA2, OUTPUT);
  pinMode(TRIGPIN, OUTPUT);
  pinMode(ECHOPIN, INPUT);
}
void loop() {
delay(100);
//Read Data from remote when available
  if (irDecoder.dataAvailable(irData)) {
    x = irData.cmd;
  }
//when button (1) is pressed do line follower, when button (2) is pressed do Romba, either is pressed default to remote conrol
  if (x == 16) {
    LineFollower();
  }
  else if (x == 17) {
    Romba();
  }
  else {
    Serial.println("Remote CTRL MODE");
    //run the direction according to remote
    if (x == 8) {
      turnleft();
      Serial.println("LEFT");
    }
    if (x == 10) {
      turnright();
      Serial.print("RIGHT");
    }
    if (x == 5) {
      gofoward();
      Serial.print("FOWARD");
    }
    if (x == 13) {
      gobackward();
      Serial.print("BACKWARD");
    }
    if (x == 0) {
      goidle();
      Serial.print("IDLE");
    }
    //reset the remote value back to 0
    x = 0;
  }
}
void LineFollower() {
//Read the line sensor
 Serial.print("IR Sensor Readings: ");
  Serial.print(IRSensor1.read()); 
  Serial.print("\t");  // tab character
  Serial.print(IRSensor2.read());
  Serial.print("\t");  // tab character
  Serial.print(IRSensor3.read()); 
  Serial.println();
  //~800 on light, ~1000 on dark
  
    
    //go left onlt if the left is dark  
  if(IRSensor2.read()<=900 && IRSensor1.read()>=925 ){
    turnleft();
    }
    //go right only if the right is dark
    else if(IRSensor2.read()<=900 && IRSensor3.read()>=925){
    turnright();
    }else{
      gofoward();
      }
}

void Romba() {
  Serial.println("doing Romba");
  //get distance value
    distance=getDistance();
    Serial.println(distance); 
    //turn left if object is too close  
  if (distance<=10){
    turnleft();
    delay(1500);
    
    }
     gofoward(); 
}

void goidle(){
  //stop movement
    digitalWrite(AIN1,LOW);
  digitalWrite(AIN2,LOW);
  analogWrite(PWMA1,50);
  
    digitalWrite(AIN3,LOW);
  digitalWrite(AIN4,LOW);
  analogWrite(PWMA2,50);
  }
void gofoward(){
  //both motor go foward
  digitalWrite(AIN1,LOW);
  digitalWrite(AIN2,HIGH);
  analogWrite(PWMA1,sp);
  
    digitalWrite(AIN3,HIGH);
  digitalWrite(AIN4,LOW);
  analogWrite(PWMA2,sp);
}

void turnright(){
  //right motor foward, left motor backward
  digitalWrite(AIN1,LOW);
  digitalWrite(AIN2,HIGH);
  analogWrite(PWMA1,sp);
  
    digitalWrite(AIN3,LOW);
  digitalWrite(AIN4,HIGH);
  analogWrite(PWMA2,sp);
}

void turnleft(){
  //rigth motor backward, left motor foward
    digitalWrite(AIN1,HIGH);
  digitalWrite(AIN2,LOW);
  analogWrite(PWMA1,sp);
  
    digitalWrite(AIN3,HIGH);
  digitalWrite(AIN4,LOW);
  analogWrite(PWMA2,sp);

}

void gobackward(){
  //both motor backward
  digitalWrite(AIN1,HIGH);
  digitalWrite(AIN2,LOW);
  analogWrite(PWMA1,sp);
  
    digitalWrite(AIN3,LOW);
  digitalWrite(AIN4,HIGH);
  analogWrite(PWMA2,sp);
}


float getDistance()
{
float echoTime; //variable to store the time it takes for a ping to bounce off an object
float calculatedDistance; //variable to store the distance calculated from the echo time
//send out an ultrasonic pulse that's 10ms long
digitalWrite(TRIGPIN, HIGH);
delayMicroseconds(10);
digitalWrite(TRIGPIN, LOW);
echoTime = pulseIn(ECHOPIN, HIGH); //use the pulsein command to see how long it takes for the
//pulse to bounce back to the sensor
calculatedDistance = echoTime / 148.0; //calculate the distance of the object that reflected the pulse
// (half the bounce time multiplied by the speed of sound)
return calculatedDistance; //send back the distance that was calculated
}
